<template>
  <q-card
    :square="!isDesktopPlatform"
    :class="{ 'fertilization-edit-form-desktop': isDesktopPlatform, 'fertilization-edit-form-mobile': !isDesktopPlatform }"
  >
    <q-form @submit="onSubmit">
      <q-card-section>
        <q-select
          v-model="fertilizer"
          :label="$gettext('Fertilizer')"
          :options="fertilizerOptions"
          option-value="id"
          option-label="name"
          filled
          :rules="[
            val => Boolean(val) || $gettext('Select a fertilizer'),
          ]"
          @update:model-value="onFertilizerChange"
        >
          <template #option="scope">
            <q-item
              v-bind="scope.itemProps"
              :clickable="!scope.opt.group"
            >
              <q-item-section v-if="scope.opt.group">
                <q-item-label
                  caption
                  class="q-ml-md"
                >
                  {{ scope.opt.group }}
                </q-item-label>
              </q-item-section>

              <q-item-section v-else>
                <q-item-label>{{ scope.opt.name }} </q-item-label>
                <q-item-label
                  v-if="scope.opt.description"
                  caption
                >
                  {{ scope.opt.description }}
                </q-item-label>
              </q-item-section>
            </q-item>
          </template>
        </q-select>

        <q-select
          v-if="hasFertilizerYearOptions"
          v-model="fertilizerYear"
          :options="fertilizerYearOptions"
          option-value="id"
          option-label="year"
          filled
          :label="$gettext('Year')"
          :rules="[
            val => Boolean(val) || $gettext('Select a year'),
          ]"
          class="q-mt-md"
        />

        <q-input
          v-model.number="fertilizerQuantity"
          step="any"
          filled
          type="number"
          :label="$gettext('Quantity')"
          :suffix="$gettext('kg/ha')"
          :min="0"
          :hint="fertilizerQuantityHint"
          class="q-mt-md"
        />
      </q-card-section>

      <q-card-actions align="right">
        <q-btn
          :label="$gettext('Cancel')"
          flat
          @click="onCancel"
        />
        <q-btn
          :label="$gettext('Remove')"
          flat
          color="red"
          @click="onDelete"
          v-if="!isNew"
        />
        <q-btn
          :label="saveButtonLabel"
          flat
          color="primary"
          type="submit"
          :disable="!canSubmit"
        />
      </q-card-actions>
    </q-form>
  </q-card>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import queryKalkulackyHnojenieComputeNutrientBalance from 'src/pages/fieldbook/fertilization/algorithms/kalkulacky-hnojenie/graphql/queryKalkulackyHnojenieComputeNutrientBalance'

export default {
  name: 'KalkulackyHnojenieFertilizationEditForm',
  mixins: [
    PlatformMixin
  ],
  props: {
    fertilizerOptions: {
      type: Array,
      required: true
    },
    id: {
      type: Number,
      default: null
    },
    initialFertilizer: {
      type: Object,
      default: null
    },
    initialFertilizerYear: {
      type: Object,
      default: null
    },
    initialFertilizerQuantity: {
      type: Number,
      default: null
    },
    initialFertilizerComputedQuantity: {
      type: Number,
      default: null
    },
    initialFertilizerType: {
      type: String,
      required: true
    }
  },
  emits: ['on-save', 'on-cancel', 'on-delete'],
  data () {
    return {
      fertilizer: this.initialFertilizer,
      fertilizerYear: this.initialFertilizerYear,
      fertilizerQuantity: this.initialFertilizerQuantity,
      fertilizerComputedQuantity: null,
      fertilizerType: this.initialFertilizerType,
      computing: false
    }
  },
  computed: {
    isNew () {
      return !this.id
    },
    saveButtonLabel () {
      return this.isNew ? this.$gettext('Add') : this.$gettext('Update')
    },
    fertilizerYearOptions () {
      if (!this.fertilizer) {
        return []
      }
      return this.fertilizer.fertilizer_years
    },
    hasFertilizerYearOptions () {
      return this.fertilizerYearOptions.length > 0
    },
    canSubmit () {
      return this.fertilizer &&
        (!this.hasFertilizerYearOptions || this.fertilizerYear) &&
        (this.fertilizerQuantity !== null && this.fertilizerQuantity !== '')
    },
    fertilizerQuantityHint () {
      if (this.computing) {
        return this.$gettext('Computing the recommended quantity...')
      } else if (this.fertilizerComputedQuantity !== null) {
        return `${this.$gettext('Recommended: ')} ${this.fertilizerComputedQuantity} ${this.$gettext('kg/ha')}`
      }
      return null
    },
    storeParameters () {
      return this.$store.state.fertilizationPlan.parameters
    },
    computeNutrientBalanceParams () {
      const params = {}

      // Crop profile
      params.preFertilizationEffect = this.storeParameters.preFertilizationEffect.name
      params.cropProfileMainProductId = this.storeParameters.cropMainProduct.id
      params.cropProfileMainProductYield = this.storeParameters.cropMainProductTargetYield

      if (this.storeParameters.cropByProduct?.id) {
        params.cropProfileByProductId = this.storeParameters.cropByProduct.id
        params.cropProfileByProductYield = this.storeParameters.cropByProductTargetYield
      }

      // Soil
      if (this.storeParameters.soilDataIsUsed) {
        params.soil = {
          density: this.storeParameters.soilDensity.name,
          ph: this.storeParameters.soilPH,
          p: this.storeParameters.soilPhosphorusContent,
          k: this.storeParameters.soilPotassiumContent,
          mg: this.storeParameters.soilMagnesiumContent
        }
      }

      // NVZ
      if (this.storeParameters.isInNVZ) {
        params.soilNitrogenMineralizationId = this.storeParameters.soilNitrogenMineralization.id
        params.growingSeasonDuration = this.storeParameters.growingSeasonDuration
      }

      // Fertilizations
      const storeFertilizations = this.storeParameters.fertilizations || []
      params.fertilizations = storeFertilizations.map(fertilization => ({
        fertilizer_id: fertilization.fertilizer.id,
        fertilizer_year_id: fertilization.fertilizerYear?.id,
        quantity: fertilization.fertilizerQuantity
      }))
      params.fertilizations.push({
        fertilizer_id: this.fertilizer.id,
        fertilizer_year_id: this.fertilizerYear?.id
      })

      return params
    }
  },
  methods: {
    onSubmit () {
      if (this.canSubmit) {
        this.$emit('on-save', {
          id: this.id,
          fertilizer: this.fertilizer,
          fertilizerYear: this.fertilizerYear,
          fertilizerQuantity: Number(this.fertilizerQuantity),
          fertilizerType: this.fertilizerType
        })
      }
    },
    onCancel () {
      this.$emit('on-cancel')
    },
    onDelete () {
      this.$emit('on-delete', this.id)
    },
    onFertilizerChange () {
      this.fertilizerYear = null
      this.fertilizerQuantity = null
      if (this.fertilizerType === 'mineral' && this.fertilizer?.id) {
        this.computeNutrientBalance()
      }
    },
    async computeNutrientBalance () {
      try {
        this.computing = true

        const { data } = await this.$apollo.query({
          query: queryKalkulackyHnojenieComputeNutrientBalance,
          variables: this.computeNutrientBalanceParams,
          fetchPolicy: 'network-only'
        })
        this.nutrientBalance = data?.nutrientBalance

        const fertilizationComputedQuantity = this.nutrientBalance?.fertilizations?.find(fert => fert.fertilizer.id === this.fertilizer.id)?.quantity
        if (fertilizationComputedQuantity != null) {
          this.fertilizerComputedQuantity = Math.round(Number(fertilizationComputedQuantity))
          if (this.fertilizerQuantity === null) {
            this.fertilizerQuantity = this.fertilizerComputedQuantity
          }
        }
      } catch (e) {
        console.error('Could not compute nutrient balance', e)
      } finally {
        this.computing = false
      }
    }
  }
}
</script>

<style scoped>
.fertilization-edit-form-desktop {
  min-width: 500px;
}
.fertilization-edit-form-mobile {
  width: 100%;
}
</style>
